pc.script.create("CamController", function (context) {
  
    var CamController = function (entity) {
        this.entity = entity;
    	this.forwVec = pc.math.vec3.create();
		this.oneVec = pc.math.vec3.create(0,0,-1);
		this.CurrentTime = 0.0;
		this.WalkTime = 0.0;
		this.AvgHeight = 25;
    };
	
	var sizeX;
	var sizeY;
	var world;
	
	var IsFree = function(pX, pY)
	{
		var posX = Math.round(pX / 50);
		var posY = Math.round(pY / 50);
		
		if(posX >= 0 && posX < sizeX && posY >= 0 && posY < sizeY)
		{
			if(world[posX + posY * sizeX] == 0)
			{
				return true;
			}
		}
		return false;
	}
 
    CamController.prototype = {
        update: function (dt) {
			
			this.CurrentTime += dt;
		
			var RotateSpeed = 80.0;
			var ForwardSpeed = 60.0;
			var BackwardSpeed = 50.0;
			var CurSpeed = 0.0;
			var DecalZ = 0.0;
			
			var cheat = false;
			if(context.keyboard.isPressed(pc.input.KEY_A))
			{
				ForwardSpeed = 120;
				BackwardSpeed = 100;
				cheat = true;
			}
			
			pc.math.quat.transformVector(this.entity.getLocalRotation(), this.oneVec, this.forwVec);
			
			if (context.keyboard.isPressed(pc.input.KEY_LEFT)) {
				this.entity.rotate(0, dt*RotateSpeed, 0);
			}
			if (context.keyboard.isPressed(pc.input.KEY_RIGHT)) {
				this.entity.rotate(0, -dt*RotateSpeed, 0);
			}
			/*if (context.keyboard.isPressed(pc.input.KEY_U)) {
				this.entity.rotate(0, 0, -dt*30);
				this.AvgHeight -= dt * 200;
			}
			if (context.keyboard.isPressed(pc.input.KEY_J)) {
				this.entity.rotate(0, 0, dt*30);
				this.AvgHeight += dt * 200;
			}*/
			if (context.keyboard.isPressed(pc.input.KEY_UP)) {
				CurSpeed += ForwardSpeed * dt;
			}
			if (context.keyboard.isPressed(pc.input.KEY_DOWN)) {
				CurSpeed -= BackwardSpeed * dt;
			}
			
			var motionX = this.forwVec[0] * CurSpeed;
			var motionY = this.forwVec[2] * CurSpeed;
						
			if(typeof this.entity._parent.world != 'undefined' && !cheat)
			{
				sizeX = this.entity._parent.sizeX;
				sizeY = this.entity._parent.sizeY;
				world = this.entity._parent.world;
				
				var Limit = 10;
				
				// Verify X motion is OK :
				
				var offsetX = (motionX > 0.0) ? Limit : ((motionX < 0.0) ? -Limit : 0.0);
				var offsetY = (motionY > 0.0) ? Limit : ((motionY < 0.0) ? -Limit : 0.0);
								
				var thisCase = IsFree(this.entity.localPosition[0], this.entity.localPosition[2]);
				var XCase = IsFree(this.entity.localPosition[0] + motionX, this.entity.localPosition[2]);
				var XCaseA = IsFree(this.entity.localPosition[0] + motionX + offsetX, this.entity.localPosition[2] - Limit);
				var XCaseB = IsFree(this.entity.localPosition[0] + motionX + offsetX, this.entity.localPosition[2] + Limit);
				
				if(thisCase && !(XCase && XCaseA && XCaseB))
				{
					motionX = 0.0;
					offsetX = 0.0;
				}
				
				// Verify Y motion is OK :
				
				var YCase = IsFree(this.entity.localPosition[0], this.entity.localPosition[2] + motionY);
				var YCaseA = IsFree(this.entity.localPosition[0] - Limit, this.entity.localPosition[2] + motionY + offsetY);
				var YCaseB = IsFree(this.entity.localPosition[0] + Limit, this.entity.localPosition[2] + motionY + offsetY);
				
				if(thisCase && !(YCase && YCaseA && YCaseB))
				{
					motionY = 0.0;
				}
				
				var height = this.AvgHeight;
				if(Math.abs(motionX) > 0.1 || Math.abs(motionX) > 0.1)
				{
					height += Math.sin(this.WalkTime * 15.0) * 1.0;
					this.WalkTime += dt;
				}
				else
				{
					this.WalkTime = 0.0;
				}
				
				DecalZ = height-this.entity.localPosition[1];				
			}
			
			this.entity.translate(motionX, DecalZ, motionY);
        }
    };
 
    return CamController;
});