pc.script.create("NPRShader", function (context) {
 
    var NPRShader = function (entity) {
        // Cache the entity that this script instance affects
        this.entity = entity;
    	this.NeedInit = true;
    };
	
	var LocalTime = 0.0;
 
    NPRShader.prototype = {
		initialize: function () {
			
			
		},
		
        update: function (dt) {
			//this.entity.rotate(0, 90 * dt, 0);
			LocalTime += dt;
			var GlobalScene = pc.scene.Scene;
			var scene = GlobalScene.current;
			if(this.NeedInit)
			{
				var curModel = this.entity.model.model;
				if(typeof GlobalScene.NPRProgram != 'undefined' && curModel && curModel.meshInstances != 'undefined' )
				{
					this.NeedInit = false;								
					
					var curInstance = curModel.meshInstances[0];
					var materials = curModel.getMaterials();
					
					var curMat = materials[0];
					
					var d1Tex = curMat.diffuseMap;
					var d2Tex = curMat.specularMap;
					var d3Tex = curMat.opacityMap;
					var d4Tex = curMat.emissiveMap;
					var normTex = curMat.normalMap;
					
					var NewMat = new pc.scene.Material();
					NewMat.setParameter("tex1", d1Tex);
					NewMat.setParameter("tex2", d2Tex);
					NewMat.setParameter("tex3", d3Tex);
					NewMat.setParameter("tex4", d4Tex);
					NewMat.setParameter("texN", normTex);

					for(i = 0;i < GlobalScene.MaxLightNum;i++)	
					{
						NewMat.setParameter("LightPos"+i, pc.math.vec4.create());
					}

					var newMaterials = [NewMat];
					NewMat.setProgram(GlobalScene.NPRProgram);
					this.MyMaterial = NewMat;
					curModel.setMaterials(newMaterials);
					curInstance.material = NewMat;
				
					var LightPos = [];
					if(typeof scene._localLights != 'undefined')
					{
						for(var i = 0;i < scene._localLights[0].length;i++)	
						{
							var basePos = scene._localLights[0][i]._position;
							var lightPos = pc.math.vec3.create(basePos[0], basePos[1], basePos[2]);
							var lightDir = pc.math.vec3.create();
							pc.math.vec3.subtract(lightPos, this.entity.localPosition, lightDir);
							var distLight = pc.math.vec3.length(lightDir);
							LightPos.push([ distLight, pc.math.vec4.create(lightPos[0], lightPos[1], lightPos[2], 1.0) ]);
							//LightPos[Math.ceil(Math.random() * 30)] = pc.math.vec4.create(lightPos[0], lightPos[1], lightPos[2], 1.0);
						}
					}
					
					LightPos.sort(function(a, b) {
							a = a[0];
							b = b[0];
							return a < b ? -1 : (a > b ? 1 : 0);
						});
					
					var LightNum = 0;
					for (var i = 0; i < LightPos.length; i++)
					{
						this.MyMaterial.setParameter("LightPos"+LightNum, LightPos[i][1]);
						++LightNum;
						if(LightNum >= (GlobalScene.MaxLightNum-1))
							break;
					}
					for(var l=LightNum; l<GlobalScene.MaxLightNum; ++l)
					{
						this.MyMaterial.setParameter("LightPos"+l, pc.math.vec4.create());
					}
					
					this.MainCamera = this.entity._parent.findByName('Camera');
				}
			}
			if(typeof this.MyMaterial != 'undefined')
			{
				this.MyMaterial.setParameter("Time", LocalTime);
				
				var CamPos = this.MainCamera.localPosition;
				this.MyMaterial.setParameter("LightPos"+(GlobalScene.MaxLightNum-1), pc.math.vec4.create(CamPos[0], CamPos[1], CamPos[2], 1.0));
				//MyInstance.material = MyMaterial;
			}
        }
    };
 
    return NPRShader;
});