pc.script.create("NPRShaderPart", function (context) {
 
    var NPRShaderPart = function (entity) {
        // Cache the entity that this script instance affects
        this.entity = entity;
    	this.NeedInit = true;
    };
 
    NPRShaderPart.prototype = {
		initialize: function () {
			
			this.LocalTime = 0.0;
		},
		
        update: function (dt) {
			//this.entity.rotate(0, 90 * dt, 0);
			this.LocalTime += dt;
			var GlobalScene = pc.scene.Scene;
			var scene = GlobalScene.current;
			if(this.NeedInit)
			{
				var curModel = this.entity.model.model;
				if(typeof GlobalScene.NPRProgram4 != 'undefined' && curModel && curModel.meshInstances != 'undefined' )
				{
					this.NeedInit = false;								
					
					var curInstance = curModel.meshInstances[0];
					var materials = curModel.getMaterials();
					
					var curMat = materials[0];
					
					var d1Tex = curMat.diffuseMap;
					
					var NewMat = new pc.scene.Material();
					NewMat.setParameter("tex1", d1Tex);

					var newMaterials = [NewMat];
					NewMat.setProgram(GlobalScene.NPRProgram4);
					this.MyMaterial = NewMat;
					curModel.setMaterials(newMaterials);
					curInstance.material = NewMat;
					NewMat.setState({ alphaTest:true
									, alphaRef:0.5
									, blend:false
									, blendModes:{srcBlend:pc.gfx.BlendMode.ZERO, dstBlend:pc.gfx.BlendMode.ONE}
									, colorWrite:{red:true, green:true, blue:true, alpha:true}
									, cull:true, depthTest:true, depthWrite:true
									, fog:false, fogColor:[0, 0, 0], fogDensity:0
									, frontFace:pc.gfx.FrontFace.CCW});
									
					this.MainCamera = this.entity._parent.findByName('Camera');
				}
			}
			if(typeof this.MyMaterial != 'undefined')
			{
				this.MyMaterial.setParameter("Time", this.LocalTime);
			}
        }
    };
 
    return NPRShaderPart;
});