pc.script.create("NPRShaderSky", function (context) {
 
    var NPRShaderSky = function (entity) {
        // Cache the entity that this script instance affects
        this.entity = entity;
    	this.NeedInit = true;
    };

    NPRShaderSky.prototype = {
		initialize: function () {
			
			this.LocalTime = 0.0;
		},
		
        update: function (dt) {
			//this.entity.rotate(0, 90 * dt, 0);
			this.LocalTime += dt;
			var GlobalScene = pc.scene.Scene;
			var scene = GlobalScene.current;
			if(this.NeedInit)
			{
				var curModel = this.entity.model.model;
				if(typeof GlobalScene.NPRProgram3 != 'undefined' && curModel && curModel.meshInstances != 'undefined' )
				{
					this.NeedInit = false;								
					
					var curInstance = curModel.meshInstances[0];
					var materials = curModel.getMaterials();
					
					var curMat = materials[0];
					
					var d1Tex = curMat.diffuseMap;
					var d2Tex = curMat.specularMap;
					var d3Tex = curMat.opacityMap;
					var d4Tex = curMat.emissiveMap;
					var normTex = curMat.normalMap;
					
					var NewMat = new pc.scene.Material();
					NewMat.setParameter("tex1", d1Tex);
					NewMat.setParameter("tex2", d2Tex);
					NewMat.setParameter("tex3", d3Tex);
					NewMat.setParameter("tex4", d4Tex);
					NewMat.setParameter("texN", normTex);

					var newMaterials = [NewMat];
					NewMat.setProgram(GlobalScene.NPRProgram3);
					this.MyMaterial = NewMat;
					curModel.setMaterials(newMaterials);
					curInstance.material = NewMat;
									
					this.MainCamera = this.entity._parent.findByName('Camera');
				}
			}
			if(typeof this.MyMaterial != 'undefined')
			{
				this.MyMaterial.setParameter("Time", this.LocalTime);
			}
        }
    };
 
    return NPRShaderSky;
});